﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Mover : MonoBehaviour
{
    private AbstractCharacter _character;
    private Transform _transform;
    private Vector2 _direction;
    private float _maxSpeed;
    public float MaxSpeed
    {
        get { return _maxSpeed; }
        set { _maxSpeed = value; }
    }

    public Vector2 Direction
    {
        get { return _direction; }
        set { _direction = value; }
    }

    void Awake()
    {
        _transform = GetComponentInParent<Transform>();
        _character = GetComponentInParent<AbstractCharacter>();
        _maxSpeed = _character != null ? _character.MaxSpeed : 1;
        _direction = Vector2.zero;
    }
    
    void Update()
    {
        if (_character != null)
        {
            _maxSpeed = _character.MaxSpeed;
        }
        Vector2 currentPosition = _transform.position;
        _transform.position = currentPosition + _maxSpeed * Time.deltaTime * _direction;
    }
}
